require(tmvtnorm)
library(utils)

#plant model
a <- 1.6
b <- 1.0

#variance of the noise
#standard deviation
sw <- 1.2

#number of iterations
N <- 200

# eps <- 0.8

#eps <- seq(0.2, 4.0, by=0.2)

#eps <- seq(0.01, 0.8, by=0.01)

#eps <- seq(0.81, 1.0, by=0.01)

#eps <- seq(1.01, 1.1, by=0.01)

eps <- seq(1.45, 4, by=0.05)

#eps <- seq(0.02, 1, by=0.02)
#eps = seq(0.05, 4, by=0.05)

#mean
mu   <- rep(0, 5)

#covariance
sigma <- matrix(rep(0, 25), 5, 5)

sigma[1,1]   <- (a^0)*sw^2;
sigma[2,1]   <- (a^1)*sw^2;
sigma[3,1]   <- (a^2)*sw^2;
sigma[4,1]   <- (a^3)*sw^2;
sigma[5,1]   <- (a^4)*sw^2;
#
sigma[1,2]   <- (a^1)*sw^2;
sigma[2,2]   <- (a^0)*(a^2+1)*sw^2;
sigma[3,2]   <- (a^1)*(a^2+1)*sw^2;
sigma[4,2]   <- (a^2)*(a^2+1)*sw^2;
sigma[5,2]   <- (a^3)*(a^2+1)*sw^2;
#
sigma[1,3]   <- (a^2)*sw^2;
sigma[2,3]   <- (a^1)*(a^2+1)*sw^2;
sigma[3,3]   <- (a^0)*(a^4+a^2+1)*sw^2;
sigma[4,3]   <- (a^1)*(a^4+a^2+1)*sw^2;
sigma[5,3]   <- (a^2)*(a^4+a^2+1)*sw^2;
#
sigma[1,4]   <- (a^3)*sw^2;
sigma[2,4]   <- (a^2)*(a^2+1)*sw^2;
sigma[3,4]   <- (a^1)*(a^4+a^2+1)*sw^2;
sigma[4,4]   <- (a^0)*(a^6+a^4+a^2+1)*sw^2;
sigma[5,4]   <- (a^1)*(a^6+a^4+a^2+1)*sw^2;
#
sigma[1,5]   <- (a^4)*sw^2;
sigma[2,5]   <- (a^3)*(a^2+1)*sw^2;
sigma[3,5]   <- (a^2)*(a^4+a^2+1)*sw^2;
sigma[4,5]   <- (a^1)*(a^6+a^4+a^2+1)*sw^2;
sigma[5,5]   <- (a^0)*(a^8+a^6+a^4+a^2+1)*sw^2;
#


# Define the variable
x  <- matrix(rep(0, 520), length(eps), 10)
y1 = 1
y2 = 1 
y3 = 1
#
y4 = 1
y5 = 1
y6 = 1

for (j in 1:length(eps)) {

lb = c(-eps[j], -eps[j], -eps[j], -eps[j], -eps[j])
ub = c( eps[j],  eps[j],  eps[j],  eps[j],  eps[j])

for (i in 1:2) {
	moments <- mtmvnorm(mean=mu[1:i], sigma[1:i,1:i], lower=lb[1:i], upper=ub[1:i])	
	x[j,i] <- moments$tvar[i,i]
	}
	
for (i in 1:N) {
	moments <- mtmvnorm(mean=mu[1:3], sigma[1:3,1:3], lower=lb[1:3], upper=ub[1:3])	
	y1[i] <- moments$tvar[3,3]
	}
	x[j,3] <- mean(y1)
				
for (i in 1:N) {
	moments <- mtmvnorm(mean=mu[1:4], sigma[1:4,1:4], lower=lb[1:4], upper=ub[1:4])	
	y2[i] <- moments$tvar[4,4]
	}
	x[j,4] <- mean(y2)
	
for (i in 1:N) {
	moments <- mtmvnorm(mean=mu[1:5], sigma[1:5,1:5], lower=lb[1:5], upper=ub[1:5])	
	y3[i] <- moments$tvar[5,5]
	}
	x[j,5] <- mean(y3)
				
	moments <- mtmvnorm(mean=mu[1:1], sigma[1:1,1:1], lower=-Inf, upper=-eps[j])	
	#
	x[j,6] <- (moments$tmean[1]^2 + moments$tvar[1,1])

	moments <- mtmvnorm(mean=mu[1:2], sigma[1:2,1:2], lower=c(lb[1:1],-Inf), upper=c(ub[1:1],-eps[j]))	
	#
	x[j,7] <- (moments$tmean[2]^2 + moments$tvar[2,2])

for (i in 1:N) {
	moments <- mtmvnorm(mean=mu[1:3], sigma[1:3,1:3], lower=c(lb[1:2],-Inf), upper=c(ub[1:2],-eps[j])) 
	#
	y4[i] <- (moments$tmean[3]^2 + moments$tvar[3,3])
	}
	x[j,8] <- mean(y4)
	
for (i in 1:N) {	
	moments <- mtmvnorm(mean=mu[1:4], sigma[1:4,1:4], lower=c(lb[1:3],-Inf), upper=c(ub[1:3],-eps[j]))	
	#
	y5[i] <- (moments$tmean[4]^2 + moments$tvar[4,4])
	}
	x[j,9] <- mean(y5)
	
for (i in 1:N) {	
	moments <- mtmvnorm(mean=mu[1:5], sigma[1:5,1:5], lower=c(lb[1:4],-Inf), upper=c(ub[1:4],-eps[j]))	
	#
	y6[i] <- (moments$tmean[5]^2 + moments$tvar[5,5])
	}
	x[j,10] <- mean(y6)

#	moments <- mtmvnorm(mean=mu, sigma, lower=a, upper=b)

	}
